// logind
// cs161 assignment 2 (fall 2005)
//
// kiran
//
// main class; only one instance of this will be created
//

#ifndef __LOGIND_H__ 
#define __LOGIND_H__


#include <nmstl/netioevent> 
#include <nmstl/terminal> 
#include <nmstl/ntime>
#include <nmstl/thread>

using namespace nmstl;


// forward declarations
class fio_handler;


// logind
// main class; a single instance is defined
//
class logind
{
  public:
    void run(int, char **);

    // configuration
    int                 port;
    string              passwd_file;
    string              mail_dir;
    int                 max_fds, cur_fds;

    // request for file i/o
    fio_handler         *get_fioh();

  private:
    static const int    FDS_PER_THREAD = 16;

    // helper
    void usage(void);

    // state
    int                 num_fiohs, cur_fioh;

    // nmstl event loop and terminal
    io_event_loop       *loop;
    term_handler        *term;

    // all the file_io_handlers
    vector<fio_handler *> *fiohs;
};


#endif  // __LOGIND_H__

