// session
// cs161 assignment 2 (fall 2005)
//
// kiran
//
// tcp_acceptor creates an instance of session for each new client
//

#ifndef __SESSION_H__ 
#define __SESSION_H__


#include <nmstl/netioevent> 
#include <nmstl/terminal> 
#include <nmstl/ntime>

using namespace nmstl;


// forward declarations
struct fio_req;
struct fio_rsp;


// session
// one for each client connection
//
class session : public net_handler<>
{
  public:
    session(io_event_loop& loop, iohandle ioh, term_handler *t);
    ~session();

    // for receiving file i/o related responses
    void fio_response(fio_rsp *);

  private:
    // console
    term_handler& term;

    // state
    bool         file_io;
    bool         dying;
    bool         authenticated;
    string       user_name;
    string       cur_tag;

    // callbacks
    int incoming_data(constbuf buf);
    void end_data(constbuf buf);

    // helpers
    void send_ok(string&, string&, string text = "completed.");
    void send_untagged(string&);
    void send_bad(string&,
            string text = "error in IMAP command received by server.");
    void send_no(string&, string&,
            string text = "unsuccessful.");
    bool get_token(string&, char, string&, int&);

    // file i/o requests
    bool list_req(string&, string&, string&);
    bool login_req(string&, string&);

    // file i/o helpers
    fio_req *prep_fio_req(int, string&);
    bool send_fio_req(fio_req *);
};


#endif  // __SESSION_H__

